namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Pixilate is an ability that turns Normal-type moves into Fairy-type moves and boosts their power.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Pixilate_(Ability)">Bulbapedia - Pixilate</see>
/// </summary>
[Script(ScriptCategory.Ability, "pixilate")]
public class Pixilate : Script, IScriptChangeMoveType, IScriptChangeBasePower
{
    /// <inheritdoc />
    public void ChangeMoveType(IExecutingMove move, IPokemon target, byte hit, ref TypeIdentifier? typeIdentifier)
    {
        if (typeIdentifier?.Name == "normal" &&
            move.Battle.Library.StaticLibrary.Types.TryGetTypeIdentifier("fairy", out var fairyType))
            typeIdentifier = fairyType;
    }

    /// <inheritdoc />
    public void ChangeBasePower(IExecutingMove move, IPokemon target, byte hit, ref ushort basePower)
    {
        if (move.GetHitData(target, hit).Type?.Name == "fairy")
            basePower = (ushort)(basePower * 1.2f); // Boost Normal-type moves by 30%
    }
}